
#ifndef SPRITEMANAGER_H_INCLUDED
#define SPRITEMANAGER_H_INCLUDED

// flags for drawSprite()
#define SPRITE_CENTERED_X   (1 << 0)
#define SPRITE_CENTERED_Y   (1 << 1)
#define SPRITE_PIVOT_BOTTOM (1 << 2)

// the sprite IDs
#define SPRITE_ID_PLAYER_CAR_FRAME_1  0
#define SPRITE_ID_PLAYER_CAR_FRAME_2  1
#define SPRITE_ID_LETTER_A            2
#define SPRITE_ID_LETTER_B            3
#define SPRITE_ID_LETTER_C            4
#define SPRITE_ID_LETTER_D            5
#define SPRITE_ID_LETTER_E            6
#define SPRITE_ID_LETTER_F            7
#define SPRITE_ID_LETTER_G            8
#define SPRITE_ID_LETTER_H            9
#define SPRITE_ID_LETTER_I           10
#define SPRITE_ID_LETTER_J           11
#define SPRITE_ID_LETTER_K           12
#define SPRITE_ID_LETTER_L           13
#define SPRITE_ID_LETTER_M           14
#define SPRITE_ID_LETTER_N           15
#define SPRITE_ID_LETTER_O           16
#define SPRITE_ID_LETTER_P           17
#define SPRITE_ID_LETTER_Q           18
#define SPRITE_ID_LETTER_R           19
#define SPRITE_ID_LETTER_S           20
#define SPRITE_ID_LETTER_T           21
#define SPRITE_ID_LETTER_U           22
#define SPRITE_ID_LETTER_V           23
#define SPRITE_ID_LETTER_W           24
#define SPRITE_ID_LETTER_X           25
#define SPRITE_ID_LETTER_Y           26
#define SPRITE_ID_LETTER_Z           27
#define SPRITE_ID_NUMBER_0           28
#define SPRITE_ID_NUMBER_1           29
#define SPRITE_ID_NUMBER_2           30
#define SPRITE_ID_NUMBER_3           31
#define SPRITE_ID_NUMBER_4           32
#define SPRITE_ID_NUMBER_5           33
#define SPRITE_ID_NUMBER_6           34
#define SPRITE_ID_NUMBER_7           35
#define SPRITE_ID_NUMBER_8           36
#define SPRITE_ID_NUMBER_9           37
#define SPRITE_ID_TWO_DOTS           38
#define SPRITE_ID_ROADSIDE_AD_1      39
#define SPRITE_ID_ROADSIDE_AD_2      40
#define SPRITE_ID_ROADSIDE_AD_3      41
#define SPRITE_ID_ROADSIDE_AD_4      42
#define SPRITE_ID_ROADSIDE_AD_5      43
#define SPRITE_ID_ROADSIDE_AD_6      44
#define SPRITE_ID_BACKGROUND_CITY    45

// some sprite colors
#define SPRITE_COLOR_SKY         255
#define SPRITE_COLOR_GROUND      254
#define SPRITE_COLOR_ROAD_1      253
#define SPRITE_COLOR_ROAD_2      252
#define SPRITE_COLOR_TACHO_BG    251
#define SPRITE_COLOR_TACHO_FG    250
#define SPRITE_COLOR_FINISH_LINE 249

class SpriteManager {

 private:

	// the sprite pixel data
	unsigned short *spriteData;

 public:

	SpriteManager(void);
	~SpriteManager(void);

	// free the current sprite sheet
	void spriteSheetFree(void);

	// actually uncompresses the specified sprite sheet
	void spriteSheetLoad(unsigned char *compressedSheet, unsigned short *palette);

	// draw a sprite
	void drawSprite(volatile unsigned short *vram, int spriteID, int sX, int sY, int flags, Viewport *viewport);

	// get the width of the sprite
	int getSpriteWidth(int spriteID);
};

#endif
